"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = toAction;

var _utils = require("../utils");

var _validation = require("./validation");

var _validation2 = _interopRequireDefault(_validation);

var _remove = require("./remove");

var _remove2 = _interopRequireDefault(_remove);

var _require2 = require("./require");

var _require3 = _interopRequireDefault(_require2);

var _uiAppend = require("./uiAppend");

var _uiAppend2 = _interopRequireDefault(_uiAppend);

var _uiReplace = require("./uiReplace");

var _uiReplace2 = _interopRequireDefault(_uiReplace);

var _uiOverride = require("./uiOverride");

var _uiOverride2 = _interopRequireDefault(_uiOverride);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DEFAULT_ACTIONS = {
  remove: _remove2.default,
  require: _require3.default,
  uiAppend: _uiAppend2.default,
  uiReplace: _uiReplace2.default,
  uiOverride: _uiOverride2.default
};

function toAction(_ref, schema, uiSchema, extraActions) {
  var _ref$event = _ref.event;
  _ref$event = _ref$event === undefined ? {} : _ref$event;
  var type = _ref$event.type,
      params = _ref$event.params;

  var action = extraActions && extraActions[type] ? extraActions[type] : DEFAULT_ACTIONS[type];
  if (action === undefined) {
    (0, _utils.toError)("Rule contains invalid action \"" + type + "\"");
  }
  if ((0, _utils.isDevelopment)()) {
    (0, _validation2.default)(action, params, schema, uiSchema);
  }
  return action;
}