"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _utils = require("../utils");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function doRequire(f, schema) {
  if (!schema.required) {
    schema.required = [];
  }

  if (schema.properties[f] === undefined) {
    console.error(f + " is missing from the schema, and can't be required");
  }

  if (schema.required.indexOf(f) === -1) {
    schema.required.push(f);
  }
}

/**
 * Makes provided field required
 *
 * @param params
 * @param schema
 * @param uiSchema
 * @returns {{schema: *, uiSchema: *}}
 */
function _require(_ref, schema) {
  var field = _ref.field;

  (0, _utils.toArray)(field).forEach(function (f) {
    return doRequire(f, (0, _utils.findRelSchema)(field, schema));
  });
}

exports.default = _require;
if ((0, _utils.isDevelopment)()) {
  _require.propTypes = {
    field: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.arrayOf(_propTypes2.default.string)]).isRequired
  };

  _require.validate = (0, _utils.validateFields)("require");
}