"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = validateAction;

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function validateAction(action, params, schema, uiSchema) {
  if (action.propTypes !== undefined && action.propTypes !== null) {
    _propTypes2.default.checkPropTypes(action.propTypes, params, "prop", action);
  }

  if (action.validate && typeof action.validate === "function") {
    if (params === undefined || params === null) {
      (0, _utils.toError)("For " + action + " validation is present, but params are missing");
    }
    action.validate(params, schema, uiSchema);
  }
}